Index: pbx.c
===================================================================
RCS file: /usr/cvsroot/asterisk/pbx.c,v
retrieving revision 1.177
diff -u -r1.177 pbx.c
--- pbx.c	24 Nov 2004 03:07:07 -0000	1.177
+++ pbx.c	24 Nov 2004 20:12:12 -0000
@@ -216,7 +216,7 @@
 
 	{ "BackGround", pbx_builtin_background,
 	"Play a file while awaiting extension",
-	"  Background(filename[|options[|langoverride]]): Plays a given file, while simultaneously\n"
+	"  Background(filename1[&filename2[&filenameN]][|options[|langoverride]]): Plays given files, while simultaneously\n"
 	"waiting for the user to begin typing an extension. The  timeouts do not\n"
 	"count until the last BackGround application has ended.\n" 
 	"Options may also be  included following a pipe symbol. The 'skip'\n"
@@ -4861,6 +4861,7 @@
 	char* stringp;
 	char* options;
 	char *lang = NULL;
+	char *front = NULL, *back = NULL;
 
 	if (!data || ast_strlen_zero(data)) {
 		ast_log(LOG_WARNING, "Background requires an argument(filename)\n");
@@ -4894,16 +4895,24 @@
 		/* Stop anything playing */
 		ast_stopstream(chan);
 		/* Stream a file */
-		res = ast_streamfile(chan, filename, lang);
-		if (!res) {
-			res = ast_waitstream(chan, AST_DIGIT_ANY);
-			ast_stopstream(chan);
-		} else {
-			ast_log(LOG_WARNING, "ast_streamfile failed on %s for %s\n", chan->name, (char*)data);
-			res = 0;
+		front = filename;
+		while(!res && front) {
+			if((back = strchr(front, '&'))) {
+				*back = '\0';
+				back++;
+			}
+			res = ast_streamfile(chan, front, lang);
+			if (!res) {
+				res = ast_waitstream(chan, AST_DIGIT_ANY);
+				ast_stopstream(chan);
+			} else {
+				ast_log(LOG_WARNING, "ast_streamfile failed on %s for %s\n", chan->name, (char*)data);
+				res = 0;
+				break;
+			}
+			front = back;
 		}
 	}
-
 	return res;
 }
 
